设为首页 收藏本站
查看: 399|回复: 0

Linux Shell脚本之Atlassian confluence远程备份方法

[复制链接]

尚未签到

发表于 2018-8-25 08:09:54 | 显示全部楼层 |阅读模式
#!/bin/bash  

  
# touch confluence_backup.sh
  
# chmod +x confluence_backup.sh
  
# vim confluence_backup.sh
  

  
# crontabs -- configuration and scripts for running periodical jobs
  
# SHELL=/bin/bash
  
# PATH=/sbin:/bin:/usr/sbin:/usr/bin
  
# MAILTO=root
  
# HOME=/
  
# For details see man 4 crontabs
  
# Example of job definition:
  
# .---------------- minute (0 - 59)
  
# |  .------------- hour (0 - 23)
  
# |  |  .---------- day of month (1 - 31)
  
# |  |  |  .------- month (1 - 12) OR jan,feb,mar,apr ...
  
# |  |  |  |  .---- day of week (0 - 6) (Sunday=0 or 7) OR sun,mon,tue,wed,thu,fri,sat
  
# |  |  |  |  |
  
# *  *  *  *  * user-name command to be executed
  
# m h  dom mon dow   command
  
# execute on 11:59 per sunday
  
# 59 11 * * */0 $0 >/tmp/confluence_backup_$(date -d "yesterday" +"%Y%m%d%H%M%S").log
  
# or
  
# execute on 23:59 per day
  
# 59 23 * * * $0 >/tmp/confluence_backup_$(date -d "yesterday" +"%Y%m%d%H%M%S").log
  

  
#     xxx.xxx.xxx.xxx                xxx.xxx.xxx.xxx
  
#           |         ssh tunnel          |
  
#     xxx.xxx.xxx.xxx    xxx.xxx.xxx.xxx
  
#           |                             |
  
# ----------+-----------------------------+-------
  
#           |                             |
  
#     +-----+-----+                +------+------+
  
#     |     A     |                |      B      |
  
#     +-----------+                +-------------+
  
#     gitlab server                backups clinet
  
#
  
# This shell script will execute on B Server
  
# A and B passed ssh Authentication
  
# A-->B: ssh lan_ip
  
# A-->B: ssh wan_ip
  
# B-->A: ssh lan_ip
  
# B-->A: ssh wan_ip
  
# A-->A: ssh lan_ip
  
# A-->A: ssh wan_ip
  
# B-->B: ssh lan_ip
  
# B-->B: ssh wan_ip
  

  
# run with root
  
# [ $(id -u) -eq 0 ] || exit 1
  
# Run as root, of course.
  
[ $UID -eq 0 ] || ( echo "Must be root to run this script." && exit 1 )
  

  
# save 10 days
  
save_days=10
  

  
# which directory to backup to
  
backup_path=/data/confluence_backup_directory
  
# make backups uniqure and backup per day
  
# backup_path_time_uniq=$(date -d "yesterday" +"%Y%m%d%H%M%S")
  
backup_path_time_uniq=$(date -d "yesterday" +"%Y%m%d")
  
confluence_home_directory=/data/var/atlassian/application-data/confluence
  
# if you have both wan ip and lan ip, you can fill it with all, if you have one ip, you can fill it just with lan ip
  
confluence_server_ipaddress_public=xxx.xxx.xxx.xxx
  
confluence_server_ipaddress_private=xxx.xxx.xxx.xxx
  
# select lan ip first for transmission speed
  
confluence_server_hostname=${confluence_server_ipaddress_private:-$confluence_server_ipaddress_public}
  
confluence_server_ssh_username=root
  
#confluence_server_ssh_port=$(awk '/Port/ {print $2}' /etc/ssh/sshd_config)
  
confluence_server_ssh_port=$(netstat -anop | awk '/sshd/ && /LISTEN/ {print $4}' | awk -F ':' '{print $2}')
  
confluence_server_ssh_hostname=$confluence_server_hostname
  

  
# which files and directory backup
  
#backup_files=(confluence.cfg.xml attachments config index)
  
backup_files=(confluence.cfg.xml attachments index)
  
backup_files_num=${#backup_files[@]}
  
[ -d $backup_path/$backup_path_time_uniq ] || mkdir -p $backup_path/$backup_path_time_uniq
  

  
# do ssh copy
  
for (( i = 0; i < $backup_files_num; i++ )); do
  scp -r -P$confluence_server_ssh_port $confluence_server_ssh_username@$confluence_server_ssh_hostname:$confluence_home_directory/${backup_files} $backup_path/$backup_path_time_uniq >/dev/null 2>&1
  [ $? -ne 0 ] && echo "$confluence_home_directory/${backup_files} Backup failed! " && exit 1;echo "$confluence_home_directory/${backup_files} Backup successfully! "
  
done
  
# excution postgresql dump
  
# PostgreSQL 9.3.9 Documentation::31.14. Environment Variables
  
# PGHOST=127.0.0.1
  
# PGHOSTADDR=127.0.0.1
  
# PGPORT=5432
  
# PGDATABASE=confluence
  
# PGUSER=confluence
  
# PGPASSWORD=yoursecret
  
# PostgreSQL 9.3.9 Documentation::31.15. The Password File
  
#cat > ~/.pgpass /dev/null 2>&1
  
[ $? -ne 0 ] && echo "PostgreSQL file transmission failed! " && exit 1;echo "PostgreSQL file transmission successfully! "
  
# delete old backups
  
find $backup_path -mtime +$save_days -exec rm -rf {} \;
  
# TODO
  
# returned code always is 0, from find or rm ???
  
# how to express real result?
  
[ $? -ne 0 ] && echo "Local expired backups remove skipped! ";echo "Local expired backups remove successfully! "



运维网声明 1、欢迎大家加入本站运维交流群:群②:261659950 群⑤:202807635 群⑦870801961 群⑧679858003
2、本站所有主题由该帖子作者发表,该帖子作者与运维网享有帖子相关版权
3、所有作品的著作权均归原作者享有,请您和我们一样尊重他人的著作权等合法权益。如果您对作品感到满意,请购买正版
4、禁止制作、复制、发布和传播具有反动、淫秽、色情、暴力、凶杀等内容的信息,一经发现立即删除。若您因此触犯法律,一切后果自负,我们对此不承担任何责任
5、所有资源均系网友上传或者通过网络收集,我们仅提供一个展示、介绍、观摩学习的平台,我们不对其内容的准确性、可靠性、正当性、安全性、合法性等负责,亦不承担任何法律责任
6、所有作品仅供您个人学习、研究或欣赏,不得用于商业或者其他用途,否则,一切后果均由您自己承担,我们对此不承担任何法律责任
7、如涉及侵犯版权等问题,请您及时通知我们,我们将立即采取措施予以解决
8、联系人Email:admin@iyunv.com 网址:www.yunweiku.com

所有资源均系网友上传或者通过网络收集,我们仅提供一个展示、介绍、观摩学习的平台,我们不对其承担任何法律责任,如涉及侵犯版权等问题,请您及时通知我们,我们将立即处理,联系人Email:kefu@iyunv.com,QQ:1061981298 本贴地址:https://www.yunweiku.com/thread-556157-1-1.html 上篇帖子: 以Linux的shell程序为入口到Teradata中执行SQL-iData 下篇帖子: shell中字符串的截取方法、cut基本用法
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

扫码加入运维网微信交流群X

扫码加入运维网微信交流群

扫描二维码加入运维网微信交流群,最新一手资源尽在官方微信交流群!快快加入我们吧...

扫描微信二维码查看详情

客服E-mail:kefu@iyunv.com 客服QQ:1061981298


QQ群⑦:运维网交流群⑦ QQ群⑧:运维网交流群⑧ k8s群:运维网kubernetes交流群


提醒:禁止发布任何违反国家法律、法规的言论与图片等内容;本站内容均来自个人观点与网络等信息,非本站认同之观点.


本站大部分资源是网友从网上搜集分享而来,其版权均归原作者及其网站所有,我们尊重他人的合法权益,如有内容侵犯您的合法权益,请及时与我们联系进行核实删除!



合作伙伴: 青云cloud

快速回复 返回顶部 返回列表